if (raisedEvent.name=='heating-controller.general-settings') {
	if (raisedEvent.parameter.actions!=null)
		if (raisedEvent.parameter.value!=null){
			if (raisedEvent.parameter.actions=='setApartmentType') {
				storeParameter('generalSettings/apartmentType',parseInt((""+raisedEvent.parameter.value),10));
				Property.store();
				new Event('heating-controller.answer',{'requestingEvent':'heating-controller.general-settings','requestingAction':'setApartmentType','result':0}).raise();
			}
			if (raisedEvent.parameter.actions=='setCentralHeatingNightModeActive') {
				storeParameter('generalSettings/centralHeatingNightModeActive',((""+raisedEvent.parameter.value)=="true"));
				Property.store();
                new Event('AddonToCloud',{"EventName":"CentralHeatingHasNightmodehandling","value":((""+raisedEvent.parameter.value)=="true")?'True':'False'}).raise();
				new Event('heating-controller.answer',{'requestingEvent':'heating-controller.general-settings','requestingAction':'setCentralHeatingNightModeActive','result':0}).raise();
			}
			if (raisedEvent.parameter.actions=='setApartmentClimateControl') {
				storeParameter('generalSettings/heatingEnabled',((""+raisedEvent.parameter.value)=="true"));				
				Property.store();
				updateApartmentControllerStatus(true, true);
				sendHeatingEnabledEvent();
				new Event('heating-controller.answer',{'requestingEvent':'heating-controller.general-settings','requestingAction':'setApartmentClimateControl','result':0}).raise();
			}
			if (raisedEvent.parameter.actions=='setUseNotUsedOnAbsent') {
				storeParameter('generalSettings/useNotUsedOnAbsent',((""+raisedEvent.parameter.value)=="true"));
				Property.store();
                new Event('AddonToCloud',{"EventName":"HeatingModeNotUsedDuringAbsence","value":((""+raisedEvent.parameter.value)=="true")?'True':'False'}).raise();
				new Event('heating-controller.answer',{'requestingEvent':'heating-controller.general-settings','requestingAction':'setUseNotUsedOnAbsent','result':0}).raise();
			}
			if (raisedEvent.parameter.actions=='setPreheatingTime') {
				storeParameter('generalSettings/preheatingTime',(raisedEvent.parameter.value));
				Property.store();
				new Event('heating-controller.answer',{'requestingEvent':'heating-controller.general-settings','requestingAction':'setPreheatingTime','result':0}).raise();
			}
			if (raisedEvent.parameter.actions=='setCentralHeatingReferenceRoom') {
				storeParameter('generalSettings/centralHeatingReferenceRoom',raisedEvent.parameter.value);
				Property.store();
				new Event('AddonToCloud',{"EventName":"IsReferenceRoom","value":raisedEvent.parameter.value}).raise();
				new Event('heating-controller.answer',{'requestingEvent':'heating-controller.general-settings','requestingAction':'setCentralHeatingReferenceRoom','result':0}).raise();
			}
            if (raisedEvent.parameter.actions=='setCapabilities') {
                var heating = ((""+raisedEvent.parameter.heating) == "true");
                var cooling = ((""+raisedEvent.parameter.cooling) == "true");
                storeParameter('generalSettings/capabilities/heatingSupported', heating);
                storeParameter('generalSettings/capabilities/coolingSupported', cooling);
                Property.store();
                updateApartmentControllerStatus(false, true);
                sendHeatingCapability();
                sendHeatingEnabledEvent();
                new Event('heating-controller.answer', { 'requestingEvent': 'heating-controller.general-settings', 'requestingAction': 'setHeatingCapabilities', 'result': 0 }).raise();
            }
		}
} else if (raisedEvent.name == 'stateChange') {
	var statename = raisedEvent.parameter.statename;
	var value     = parseInt("" + raisedEvent.parameter.value, 10);
	lInfo.logln("state Change: " + statename + " value: " + value);
	if (statename == 'heating_water_system') {
		lInfo.logln("state Change: " + statename + " value: " + value);
		// values:  0: Off  -> no water, 1: Heat -> hot water, 2: Cold -> cold water, 3 : auto(not supported)
		if (value < 3) {
			updateApartmentControllerStatus(true, true);
			sendHeatingEnabledEvent();
		}
	}
}